import java.io.*;
import java.net.*;
import java.lang.reflect.*;

public class FileHandler extends FileManager
{
	private static String [] predicate={"","lar"};
	private HandlerCollector collector;
	public FileHandler(Socket socket,HandlerCollector collector,File local_pwd)
	{
		super(socket,local_pwd);
		if (not_exit) {
			no_to_all=false;
			not_yes_all=true;
			this.collector=collector;
		}
	}

	public void peerMessage(byte command,String message,byte cont)
	{
		userMessage(command,message,cont);
	}

	public byte getUserChoice(String file)
	{
		try {
			int choice;
			writeByte(4);
			switch ((choice=readByte())) {
				case 1:
					no_to_all=true;
					break;
				case 3:
					not_yes_all=false;
					break;
			}
			return (byte)choice;
		} catch (SocketException se) {
			return (byte)0;
		}
	}

	
	private void getFile()
	{
		try {
			File f=getAbsoluteFile(reply);
			if (downloadFile(f) == FM_DOWNLOAD_OK) {
				return;
			}
		} catch (SocketException se) { }
		catch (Exception e) {
			try {
				writeByte(0);
			} catch (SocketException se) {}
		}
	}
			
	private void processResponse()
	{
		do {
			readCommand();
			switch (r_type) {
				case 0:
				case 1:
					break;
				case 3:
					getFile();
					break;
				case 4 :
					mkdir();
					break;
				case 6 :
					try {
						if (changeLocalPWD(reply)) {
							writeByte(1);
						} else {
							writeByte(0);
						}
					} catch (SocketException se) { }
					break;
				case 7:
					try {
						writeLine(local_pwd.getAbsolutePath().getBytes());
					} catch (SocketException se) { }
					break;
				case 100:
					break;
				default:
					peerMessage((byte)0,"Hata: Bu komut bilinmiyor",(byte)0);
					break;
			}
		} while (not_exit && cont == 1);
	}

	public void screenMessage(String message)
	{
	}

	public void screenMessage(char message)
	{
	}

	public void mput(String [] cmd,String cmdStr)
	{
		if (cmd.length >= 2) {
			int i,j;
			for (j=0,i=1; i < cmd.length; i++) {
				splitSourceTarget(cmd[i],srcTrg);
				if (srcTrg[0] == null) {
					userMessage((byte)0,"Hata: Bos hedef ismi: Durum "+cmd[i],(byte)1);
					++j;
				}
			}
			if (j == 0) {
				userMessage((byte)10,cmdStr,(byte)1);
				processResponse();
				userMessage((byte)1,cmdStr+" tamamlandi",(byte)0);
			} else {
				j= j == 1 ? 0 : 1;
				userMessage((byte)0,"Hata "+predicate[j]+" var. Iptal ediliyor",(byte)0);
			}
		} else {
			userMessage((byte)0,"Yetersiz sayida degistirge",(byte)0);
		}
	}
		
	public void put(String [] cmd,String cmdStr)
	{
		if (cmd.length == 2) {
			try {
				splitSourceTarget(cmd[1],srcTrg);
				if (srcTrg[0] == null) {
					userMessage((byte)0,"Hata: Bos hedef ismi:Durum "+cmd[1]+". Iptal Ediliyor",(byte)0);
					return;
				}
				userMessage((byte)9,"get "+cmd[1],(byte)1);
				processResponse();
				userMessage((byte)1,cmdStr+" tamamlandi",(byte)0);
			} catch (Exception e) {
				try {
					writeInt(0);
				} catch (SocketException se) {}
			}
		} else {
			userMessage((byte)0,"Yetersiz sayida degistirge",(byte)0);
		}
	}

	public void run()
	{
		userMessage((byte)1,local_pwd.getAbsolutePath(),(byte)0);
		while (not_exit) {
			try {
				String cmdStr=readLine().trim();
				String []cmd=splitCommand(cmdStr);
				Method m=this.getClass().getMethod(cmd[0],ARGV);
				m.invoke(this,new Object[]{cmd,cmdStr});
				no_to_all=false;
				not_yes_all=true;
			} catch(Exception e) {
				userMessage((byte)0,"Hata: Boyle bir komut desteklenmiyor",(byte)0);
			}
		}
		collector.killMe(this);
	}
}
