import java.io.*;

public class ProcessHandler
{
	private Runtime runtime;
	private OutputStream proc_out;

	public ProcessHandler()
	{
		runtime=Runtime.getRuntime();
	}
	private void kill(Thread t)
	{
		do {
			try {
				t.join();
				return;
			} catch (Exception ie) {}

		} while (true);
	}

	public void runCommand(String cmd)
	{
		try {
			proc_out.write(cmd.getBytes());
			proc_out.flush();
		} catch (Exception e) {
			System.err.println("Beklenmedik Durum: "+e.getMessage());
		}
	}
	
	public void exec(String cmd)
	{
		try {
			Process p=runtime.exec(cmd);
			proc_out=p.getOutputStream();
			PipeHandler stdout=new PipeHandler(p.getInputStream(),System.out);
			PipeHandler stderr=new PipeHandler(p.getErrorStream(),System.err);
			PipeHandler stdin=new PipeHandler(System.in,proc_out);
			stdin.start();
			stdout.start();
			stderr.start();
			do {
				try {
					p.waitFor();
					kill(stdin);
					kill(stdout);
					kill(stderr);
					break;
				} catch (InterruptedException ie) {}
			} while (true);
		} catch (Exception e) {
			System.err.println("Islemci hatasi: "+e.getMessage());
		}
	}
}