import java.io.*;
import java.net.*;

public class Server
{
 public static void main(String args[])
 {
  if (args.length == 2) {
   try {
    File pwd=new File(args[1]);
    if (pwd.isDirectory()) {
     HandlerCollector collector=new HandlerCollector();
     ServerSocket server=new ServerSocket(Integer.parseInt(args[0]));
     collector.start();
     while (collector.isAlive()) {
      try {
       Socket s=server.accept();
       FileHandler f=new FileHandler(s,collector,pwd);
       f.start();
      } catch(Exception e) {
       System.err.println("Beklenmedik Durum: "+e.getMessage());
      }
     }
    } else {
     System.err.println("Hata: "+args[1]+" bir dizin degil");
    }
   } catch(Exception e2) {
    System.err.println("Olumcul Hata: "+e2.getMessage());
   }
  } else {
   System.out.println("Kullanim: Server <sunucu port numarasi> <istemci baslangic dizini yolu>");
  }
 }
}
 